#!/bin/env python
#-*- coding: utf-8 -*-
# 1行目は cygwin で使うときのおまじない
# 2行目は日本語コードの指定
#
# perfectnumber.py
# 完全数の探索
# 2007.4.25

from math import *	# 数学関数を使うためのまじない
from time import *	# 時間関数を使うためのまじない
from sys import *	# システム関数を使うためのまじない

# 真の約数の和
def divisor_sum(n):
	sq = sqrt(n)
	s = 1
	x = 2
	while x <= sq:
		if n % x == 0:		# x が約数なら
			s += x		# x を加える
			if x != sq:		# x^2 != n なら
				s += n / x	# n/x も約数
		x += 1
	return s

# 真の約数の和のリスト
def divisor_list(n):
	sq = sqrt(n)
	s = [1]
	x = 2
	while x <= sq:
		if n % x == 0:		# x が約数なら
			s.append(x)		# x を加える
			if x != sq:		# x^2 != n なら
				s.append(n / x)	# n/x も約数
		x += 1
	s.sort()
	return s

print u"完全数を探索します。"
print u"真の約数の和が自分自身になる数を完全数と言います。"
print
print u"いくつまで探索しますか。"
max = input()

t0 = time()		# 開始時刻
a = 2
c = 0
while a <= max:
	if divisor_sum(a) == a:
		c += 1
		print u"%d は %d 個目の完全数です。" % (a,c)
		print u"真の約数は ",divisor_list(a)
		print
	a += 1
t1 = time()		# 終了時刻
print u"計算時間 =", t1 - t0

